/*
 * generated by Xtext 2.16.0
 */
package org.protelis.parser.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.protelis.parser.protelis.AlignedMap;
import org.protelis.parser.protelis.Assignment;
import org.protelis.parser.protelis.Block;
import org.protelis.parser.protelis.BooleanVal;
import org.protelis.parser.protelis.BuiltinHoodOp;
import org.protelis.parser.protelis.Call;
import org.protelis.parser.protelis.DoubleVal;
import org.protelis.parser.protelis.E;
import org.protelis.parser.protelis.Env;
import org.protelis.parser.protelis.Eval;
import org.protelis.parser.protelis.ExprList;
import org.protelis.parser.protelis.Expression;
import org.protelis.parser.protelis.FunctionDef;
import org.protelis.parser.protelis.GenericHood;
import org.protelis.parser.protelis.If;
import org.protelis.parser.protelis.Import;
import org.protelis.parser.protelis.ImportDeclaration;
import org.protelis.parser.protelis.ImportSection;
import org.protelis.parser.protelis.Lambda;
import org.protelis.parser.protelis.Mux;
import org.protelis.parser.protelis.NBR;
import org.protelis.parser.protelis.Pi;
import org.protelis.parser.protelis.Prefix;
import org.protelis.parser.protelis.ProtelisModule;
import org.protelis.parser.protelis.ProtelisPackage;
import org.protelis.parser.protelis.Rep;
import org.protelis.parser.protelis.RepInitialize;
import org.protelis.parser.protelis.Self;
import org.protelis.parser.protelis.StringVal;
import org.protelis.parser.protelis.TupleVal;
import org.protelis.parser.protelis.VarDef;
import org.protelis.parser.protelis.VarDefList;
import org.protelis.parser.protelis.VarUse;
import org.protelis.parser.services.ProtelisGrammarAccess;

@SuppressWarnings("all")
public class ProtelisSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private ProtelisGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == ProtelisPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case ProtelisPackage.ALIGNED_MAP:
				sequence_AlignedMap(context, (AlignedMap) semanticObject); 
				return; 
			case ProtelisPackage.ASSIGNMENT:
				sequence_Assignment(context, (Assignment) semanticObject); 
				return; 
			case ProtelisPackage.BLOCK:
				sequence_Block(context, (Block) semanticObject); 
				return; 
			case ProtelisPackage.BOOLEAN_VAL:
				sequence_BooleanVal(context, (BooleanVal) semanticObject); 
				return; 
			case ProtelisPackage.BUILTIN_HOOD_OP:
				sequence_BuiltinHoodOp(context, (BuiltinHoodOp) semanticObject); 
				return; 
			case ProtelisPackage.CALL:
				sequence_Call(context, (Call) semanticObject); 
				return; 
			case ProtelisPackage.DOUBLE_VAL:
				sequence_DoubleVal(context, (DoubleVal) semanticObject); 
				return; 
			case ProtelisPackage.E:
				sequence_E(context, (E) semanticObject); 
				return; 
			case ProtelisPackage.ENV:
				sequence_Env(context, (Env) semanticObject); 
				return; 
			case ProtelisPackage.EVAL:
				sequence_Eval(context, (Eval) semanticObject); 
				return; 
			case ProtelisPackage.EXPR_LIST:
				sequence_ExprList(context, (ExprList) semanticObject); 
				return; 
			case ProtelisPackage.EXPRESSION:
				sequence_Addition_Equality_LogicalAnd_LogicalOr_Multiplication_Postfix_Power_Primary_Relational(context, (Expression) semanticObject); 
				return; 
			case ProtelisPackage.FUNCTION_DEF:
				sequence_FunctionDef(context, (FunctionDef) semanticObject); 
				return; 
			case ProtelisPackage.GENERIC_HOOD:
				sequence_GenericHood(context, (GenericHood) semanticObject); 
				return; 
			case ProtelisPackage.IF:
				sequence_If(context, (If) semanticObject); 
				return; 
			case ProtelisPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case ProtelisPackage.IMPORT_DECLARATION:
				sequence_ImportDeclaration(context, (ImportDeclaration) semanticObject); 
				return; 
			case ProtelisPackage.IMPORT_SECTION:
				sequence_ImportSection(context, (ImportSection) semanticObject); 
				return; 
			case ProtelisPackage.LAMBDA:
				sequence_Lambda(context, (Lambda) semanticObject); 
				return; 
			case ProtelisPackage.MUX:
				sequence_Mux(context, (Mux) semanticObject); 
				return; 
			case ProtelisPackage.NBR:
				sequence_NBR(context, (NBR) semanticObject); 
				return; 
			case ProtelisPackage.PI:
				sequence_Pi(context, (Pi) semanticObject); 
				return; 
			case ProtelisPackage.PREFIX:
				sequence_Prefix(context, (Prefix) semanticObject); 
				return; 
			case ProtelisPackage.PROTELIS_MODULE:
				sequence_ProtelisModule(context, (ProtelisModule) semanticObject); 
				return; 
			case ProtelisPackage.REP:
				sequence_Rep(context, (Rep) semanticObject); 
				return; 
			case ProtelisPackage.REP_INITIALIZE:
				sequence_RepInitialize(context, (RepInitialize) semanticObject); 
				return; 
			case ProtelisPackage.SELF:
				sequence_Self(context, (Self) semanticObject); 
				return; 
			case ProtelisPackage.STRING_VAL:
				sequence_StringVal(context, (StringVal) semanticObject); 
				return; 
			case ProtelisPackage.TUPLE_VAL:
				sequence_TupleVal(context, (TupleVal) semanticObject); 
				return; 
			case ProtelisPackage.VAR_DEF:
				if (rule == grammarAccess.getStatementRule()
						|| rule == grammarAccess.getDeclarationRule()) {
					sequence_Declaration_VarDef(context, (VarDef) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getVarDefRule()) {
					sequence_VarDef(context, (VarDef) semanticObject); 
					return; 
				}
				else break;
			case ProtelisPackage.VAR_DEF_LIST:
				sequence_VarDefList(context, (VarDefList) semanticObject); 
				return; 
			case ProtelisPackage.VAR_USE:
				sequence_VarUse(context, (VarUse) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Statement returns Expression
	 *     Expression returns Expression
	 *     LogicalOr returns Expression
	 *     LogicalOr.Expression_1_0 returns Expression
	 *     LogicalAnd returns Expression
	 *     LogicalAnd.Expression_1_0 returns Expression
	 *     Equality returns Expression
	 *     Equality.Expression_1_0 returns Expression
	 *     Relational returns Expression
	 *     Relational.Expression_1_0 returns Expression
	 *     Addition returns Expression
	 *     Addition.Expression_1_0 returns Expression
	 *     Multiplication returns Expression
	 *     Multiplication.Expression_1_0 returns Expression
	 *     Power returns Expression
	 *     Power.Expression_1_0 returns Expression
	 *     Prefix returns Expression
	 *     Postfix returns Expression
	 *     Postfix.Expression_1_0 returns Expression
	 *     Primary returns Expression
	 *
	 * Constraint:
	 *     (
	 *         (left=LogicalOr_Expression_1_0 name='||' right=LogicalAnd) | 
	 *         (left=LogicalAnd_Expression_1_0 name='&&' right=Equality) | 
	 *         (left=Equality_Expression_1_0 (name='==' | name='!=') right=Relational) | 
	 *         (left=Relational_Expression_1_0 (name='>' | name='>=' | name='<' | name='<=') right=Addition) | 
	 *         (left=Addition_Expression_1_0 (name='+' | name='-') right=Multiplication) | 
	 *         (left=Multiplication_Expression_1_0 (name='*' | name='/' | name='%') right=Power) | 
	 *         (left=Power_Expression_1_0 name='^' right=Prefix) | 
	 *         (left=Postfix_Expression_1_0 name='.' methodName=AID args=ExprList?) | 
	 *         v=VarUse | 
	 *         v=Local | 
	 *         v=Call | 
	 *         v=Rep | 
	 *         v=NBR | 
	 *         v=If
	 *     )
	 */
	protected void sequence_Addition_Equality_LogicalAnd_LogicalOr_Multiplication_Postfix_Power_Primary_Relational(ISerializationContext context, Expression semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns AlignedMap
	 *     AlignedMap returns AlignedMap
	 *     Local returns AlignedMap
	 *
	 * Constraint:
	 *     (name='alignedMap' arg=Expression cond=Expression op=Expression default=Expression)
	 */
	protected void sequence_AlignedMap(ISerializationContext context, AlignedMap semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__ARG) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__ARG));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__COND) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__COND));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__OP) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__OP));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__DEFAULT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.ALIGNED_MAP__DEFAULT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAlignedMapAccess().getNameAlignedMapKeyword_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getAlignedMapAccess().getArgExpressionParserRuleCall_2_0(), semanticObject.getArg());
		feeder.accept(grammarAccess.getAlignedMapAccess().getCondExpressionParserRuleCall_4_0(), semanticObject.getCond());
		feeder.accept(grammarAccess.getAlignedMapAccess().getOpExpressionParserRuleCall_6_0(), semanticObject.getOp());
		feeder.accept(grammarAccess.getAlignedMapAccess().getDefaultExpressionParserRuleCall_8_0(), semanticObject.getDefault());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Statement returns Assignment
	 *     Assignment returns Assignment
	 *
	 * Constraint:
	 *     (refVar=[VarDef|ID] name='=' right=Expression)
	 */
	protected void sequence_Assignment(ISerializationContext context, Assignment semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.ASSIGNMENT__REF_VAR) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.ASSIGNMENT__REF_VAR));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STATEMENT__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STATEMENT__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAssignmentAccess().getRefVarVarDefIDTerminalRuleCall_0_0_1(), semanticObject.eGet(ProtelisPackage.Literals.ASSIGNMENT__REF_VAR, false));
		feeder.accept(grammarAccess.getAssignmentAccess().getNameEqualsSignKeyword_1_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getAssignmentAccess().getRightExpressionParserRuleCall_2_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Block returns Block
	 *
	 * Constraint:
	 *     (first=Statement others=Block?)
	 */
	protected void sequence_Block(ISerializationContext context, Block semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Local returns BooleanVal
	 *     Scalar returns BooleanVal
	 *     BooleanVal returns BooleanVal
	 *
	 * Constraint:
	 *     val=BOOLEAN
	 */
	protected void sequence_BooleanVal(ISerializationContext context, BooleanVal semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BOOLEAN_VAL__VAL) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BOOLEAN_VAL__VAL));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getBooleanValAccess().getValBOOLEANParserRuleCall_0(), semanticObject.isVal());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns BuiltinHoodOp
	 *     Hood returns BuiltinHoodOp
	 *     BuiltinHoodOp returns BuiltinHoodOp
	 *     Local returns BuiltinHoodOp
	 *
	 * Constraint:
	 *     (
	 *         (
	 *             name='minHood' | 
	 *             name='maxHood' | 
	 *             name='anyHood' | 
	 *             name='allHood' | 
	 *             name='sumHood' | 
	 *             name='meanHood' | 
	 *             name='unionHood'
	 *         ) 
	 *         inclusive?='PlusSelf'? 
	 *         arg=Expression
	 *     )
	 */
	protected void sequence_BuiltinHoodOp(ISerializationContext context, BuiltinHoodOp semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Call returns Call
	 *
	 * Constraint:
	 *     (reference=[EObject|CallRule] args=ExprList?)
	 */
	protected void sequence_Call(ISerializationContext context, Call semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Statement returns VarDef
	 *     Declaration returns VarDef
	 *
	 * Constraint:
	 *     (name=ID right=Expression)
	 */
	protected void sequence_Declaration_VarDef(ISerializationContext context, VarDef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STATEMENT__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STATEMENT__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getVarDefAccess().getNameIDTerminalRuleCall_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getDeclarationAccess().getRightExpressionParserRuleCall_3_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Local returns DoubleVal
	 *     Scalar returns DoubleVal
	 *     DoubleVal returns DoubleVal
	 *
	 * Constraint:
	 *     val=DOUBLE
	 */
	protected void sequence_DoubleVal(ISerializationContext context, DoubleVal semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.DOUBLE_VAL__VAL) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.DOUBLE_VAL__VAL));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDoubleValAccess().getValDOUBLEParserRuleCall_0(), semanticObject.getVal());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns E
	 *     E returns E
	 *     Local returns E
	 *
	 * Constraint:
	 *     name='e'
	 */
	protected void sequence_E(ISerializationContext context, E semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEAccess().getNameEKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns Env
	 *     Env returns Env
	 *     Local returns Env
	 *
	 * Constraint:
	 *     name='env'
	 */
	protected void sequence_Env(ISerializationContext context, Env semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getEnvAccess().getNameEnvKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns Eval
	 *     Eval returns Eval
	 *     Local returns Eval
	 *
	 * Constraint:
	 *     (name='eval' (arg=VarUse | arg=StringVal))
	 */
	protected void sequence_Eval(ISerializationContext context, Eval semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ExprList returns ExprList
	 *
	 * Constraint:
	 *     (args+=Expression args+=Expression*)
	 */
	protected void sequence_ExprList(ISerializationContext context, ExprList semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     FunctionDef returns FunctionDef
	 *
	 * Constraint:
	 *     (public?='public'? name=ID args=VarDefList? body=Block)
	 */
	protected void sequence_FunctionDef(ISerializationContext context, FunctionDef semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns GenericHood
	 *     Hood returns GenericHood
	 *     GenericHood returns GenericHood
	 *     Local returns GenericHood
	 *
	 * Constraint:
	 *     ((name='hood' | name='hoodPlusSelf') (reference=VarUse | op=Lambda) default=Expression arg=Expression)
	 */
	protected void sequence_GenericHood(ISerializationContext context, GenericHood semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     If returns If
	 *
	 * Constraint:
	 *     (name='if' cond=Expression then=Block else=Block)
	 */
	protected void sequence_If(ISerializationContext context, If semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.IF__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.IF__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.IF__COND) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.IF__COND));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.IF__THEN) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.IF__THEN));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.IF__ELSE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.IF__ELSE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getIfAccess().getNameIfKeyword_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getIfAccess().getCondExpressionParserRuleCall_2_0(), semanticObject.getCond());
		feeder.accept(grammarAccess.getIfAccess().getThenBlockParserRuleCall_5_0(), semanticObject.getThen());
		feeder.accept(grammarAccess.getIfAccess().getElseBlockParserRuleCall_9_0(), semanticObject.getElse());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     ImportDeclaration returns ImportDeclaration
	 *
	 * Constraint:
	 *     (importedType=[JvmDeclaredType|QualifiedNameInStaticImport] (wildcard?='*' | memberName=AID))
	 */
	protected void sequence_ImportDeclaration(ISerializationContext context, ImportDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ImportSection returns ImportSection
	 *
	 * Constraint:
	 *     importDeclarations+=ImportDeclaration+
	 */
	protected void sequence_ImportSection(ISerializationContext context, ImportSection semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Import returns Import
	 *
	 * Constraint:
	 *     module=[ProtelisModule|ProtelisQualifiedName]
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.IMPORT__MODULE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.IMPORT__MODULE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImportAccess().getModuleProtelisModuleProtelisQualifiedNameParserRuleCall_1_0_1(), semanticObject.eGet(ProtelisPackage.Literals.IMPORT__MODULE, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Lambda returns Lambda
	 *     Local returns Lambda
	 *
	 * Constraint:
	 *     ((args=VarDefList | args=VarDef)? name='->' body=Block)
	 */
	protected void sequence_Lambda(ISerializationContext context, Lambda semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns Mux
	 *     Mux returns Mux
	 *     Local returns Mux
	 *
	 * Constraint:
	 *     (name='mux' cond=Expression then=Block else=Block)
	 */
	protected void sequence_Mux(ISerializationContext context, Mux semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.MUX__COND) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.MUX__COND));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.MUX__THEN) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.MUX__THEN));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.MUX__ELSE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.MUX__ELSE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getMuxAccess().getNameMuxKeyword_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getMuxAccess().getCondExpressionParserRuleCall_2_0(), semanticObject.getCond());
		feeder.accept(grammarAccess.getMuxAccess().getThenBlockParserRuleCall_5_0(), semanticObject.getThen());
		feeder.accept(grammarAccess.getMuxAccess().getElseBlockParserRuleCall_9_0(), semanticObject.getElse());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     NBR returns NBR
	 *
	 * Constraint:
	 *     (name='nbr' arg=Expression)
	 */
	protected void sequence_NBR(ISerializationContext context, NBR semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.NBR__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.NBR__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.NBR__ARG) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.NBR__ARG));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getNBRAccess().getNameNbrKeyword_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getNBRAccess().getArgExpressionParserRuleCall_2_0(), semanticObject.getArg());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns Pi
	 *     Pi returns Pi
	 *     Local returns Pi
	 *
	 * Constraint:
	 *     name='pi'
	 */
	protected void sequence_Pi(ISerializationContext context, Pi semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPiAccess().getNamePiKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Statement returns Prefix
	 *     Expression returns Prefix
	 *     LogicalOr returns Prefix
	 *     LogicalOr.Expression_1_0 returns Prefix
	 *     LogicalAnd returns Prefix
	 *     LogicalAnd.Expression_1_0 returns Prefix
	 *     Equality returns Prefix
	 *     Equality.Expression_1_0 returns Prefix
	 *     Relational returns Prefix
	 *     Relational.Expression_1_0 returns Prefix
	 *     Addition returns Prefix
	 *     Addition.Expression_1_0 returns Prefix
	 *     Multiplication returns Prefix
	 *     Multiplication.Expression_1_0 returns Prefix
	 *     Power returns Prefix
	 *     Power.Expression_1_0 returns Prefix
	 *     Prefix returns Prefix
	 *     Postfix returns Prefix
	 *     Postfix.Expression_1_0 returns Prefix
	 *     Primary returns Prefix
	 *
	 * Constraint:
	 *     ((name='-' | name='!') right=Postfix)
	 */
	protected void sequence_Prefix(ISerializationContext context, Prefix semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ProtelisModule returns ProtelisModule
	 *
	 * Constraint:
	 *     (
	 *         (name=ProtelisQualifiedName ((protelisImport+=Import+ program=Block) | program=Block)) | 
	 *         (
	 *             ((name=ProtelisQualifiedName javaimports=ImportSection) | javaimports=ImportSection) 
	 *             ((protelisImport+=Import+ program=Block) | program=Block)
	 *         ) | 
	 *         (
	 *             (
	 *                 (name=ProtelisQualifiedName ((javaimports=ImportSection protelisImport+=Import+) | protelisImport+=Import+)) | 
	 *                 (javaimports=ImportSection protelisImport+=Import+) | 
	 *                 protelisImport+=Import+
	 *             )? 
	 *             definitions+=FunctionDef+ 
	 *             program=Block
	 *         ) | 
	 *         (protelisImport+=Import+ program=Block) | 
	 *         program=Block
	 *     )?
	 */
	protected void sequence_ProtelisModule(ISerializationContext context, ProtelisModule semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     RepInitialize returns RepInitialize
	 *
	 * Constraint:
	 *     (x=VarDef w=Expression)
	 */
	protected void sequence_RepInitialize(ISerializationContext context, RepInitialize semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.REP_INITIALIZE__X) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.REP_INITIALIZE__X));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.REP_INITIALIZE__W) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.REP_INITIALIZE__W));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getRepInitializeAccess().getXVarDefParserRuleCall_0_0(), semanticObject.getX());
		feeder.accept(grammarAccess.getRepInitializeAccess().getWExpressionParserRuleCall_2_0(), semanticObject.getW());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Rep returns Rep
	 *
	 * Constraint:
	 *     (name='rep' init=RepInitialize body=Block)
	 */
	protected void sequence_Rep(ISerializationContext context, Rep semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.REP__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.REP__NAME));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.REP__INIT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.REP__INIT));
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.REP__BODY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.REP__BODY));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getRepAccess().getNameRepKeyword_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getRepAccess().getInitRepInitializeParserRuleCall_2_0(), semanticObject.getInit());
		feeder.accept(grammarAccess.getRepAccess().getBodyBlockParserRuleCall_5_0(), semanticObject.getBody());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Builtin returns Self
	 *     Self returns Self
	 *     Local returns Self
	 *
	 * Constraint:
	 *     name='self'
	 */
	protected void sequence_Self(ISerializationContext context, Self semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.BUILTIN__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getSelfAccess().getNameSelfKeyword_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Local returns StringVal
	 *     Scalar returns StringVal
	 *     StringVal returns StringVal
	 *
	 * Constraint:
	 *     val=STRING
	 */
	protected void sequence_StringVal(ISerializationContext context, StringVal semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STRING_VAL__VAL) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STRING_VAL__VAL));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getStringValAccess().getValSTRINGTerminalRuleCall_0(), semanticObject.getVal());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Local returns TupleVal
	 *     Scalar returns TupleVal
	 *     TupleVal returns TupleVal
	 *
	 * Constraint:
	 *     (name='[' args=ExprList?)
	 */
	protected void sequence_TupleVal(ISerializationContext context, TupleVal semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     VarDefList returns VarDefList
	 *
	 * Constraint:
	 *     (args+=VarDef args+=VarDef*)
	 */
	protected void sequence_VarDefList(ISerializationContext context, VarDefList semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     VarDef returns VarDef
	 *
	 * Constraint:
	 *     name=ID
	 */
	protected void sequence_VarDef(ISerializationContext context, VarDef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.STATEMENT__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getVarDefAccess().getNameIDTerminalRuleCall_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     VarUse returns VarUse
	 *
	 * Constraint:
	 *     reference=[EObject|CallRuleNoConflict]
	 */
	protected void sequence_VarUse(ISerializationContext context, VarUse semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ProtelisPackage.Literals.VAR_USE__REFERENCE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ProtelisPackage.Literals.VAR_USE__REFERENCE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getVarUseAccess().getReferenceEObjectCallRuleNoConflictParserRuleCall_0_1(), semanticObject.eGet(ProtelisPackage.Literals.VAR_USE__REFERENCE, false));
		feeder.finish();
	}
	
	
}
